       TITLE 'SFFEXMPL - Sample application for SFF Support Pac'
      *****************************************************************
      *                                                               *
      * MODULE NAME = SFFEXMPL                                        *
      *                                                               *
      * DESCRIPTIVE NAME = SFF Example application                    *
      *                                                               *
      * STATUS = SUPPORTED BY CICS SERVICE FLOW FEATURE FOR           *
      *          CICS TRANSACTION SERVER v3.2                         *
      *                                                               *
      *---------------------------------------------------------------*
      * @START_RRS_COPYRIGHT@                                                   
      * VERSION: 1                                                              
      *                                                                         
      * Licensed Materials - Property of IBM                                    
      *                                                                         
      * 5655-M15                                                                
      *                                                                         
      * (C) Copyright IBM Corp. 2008                                            
      * @END_RRS_COPYRIGHT@                                                     
      *****************************************************************
      *             PROGRAM DESCRIPTION                               *
      * This application serves two purposes:                         *
      * 1)                                                            *
      * This program reads additional arguments (if any) from the     *
      * screen when started.                                          *
      * Drives the example Service Flow with appropriate data via the *
      * CICS channel interface.                                       *
      * Once the Service Flow has terminated, this program will check *
      * the results from the Service Flow and report directly to the  *
      * screen                                                        *
      * 2)                                                            *
      * This application is also queried by the Service Flow          *
      * execution to test the Program Link setup                      *
      *****************************************************************
       IDENTIFICATION DIVISION.
       PROGRAM-ID.  SFFEXMPL.
      *
       AUTHOR.      IBM.
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES.
       SOURCE-COMPUTER.  IBM-370.
       OBJECT-COMPUTER.  IBM-370.
      *
       DATA DIVISION.

       WORKING-STORAGE SECTION.

       01 SCREEN-INPUT-STRING      PIC X(07) VALUE SPACES.
       01 SCREEN-DATA.
          05 TRAN-ID               PIC X(04) VALUE SPACES.
          05 TRAN-ARG              PIC X(02) VALUE SPACES.
       01 SCREEN-OUTPUT-STRING.
          05 TRAN-ID-TEXT          PIC X(04) VALUE 'SFF1'.
          05 FILLER                PIC X(01) VALUE SPACES.
          05 PL-TEXT               PIC X(09) VALUE 'ProgLink('.
          05 PL-RES                PIC X(07) VALUE SPACES.
             88 PL-RES-PASS                  VALUE 'Pass'.
             88 PL-RES-FAIL                  VALUE 'Fail'.
             88 PL-RES-NA                    VALUE 'Not Run'.
          05 CLSE-R-1              PIC X(01) VALUE ')'.
          05 FILLER                PIC X(01) VALUE SPACES.
          05 LB-TEXT               PIC X(09) VALUE 'Link3270('.
          05 LB-RES                PIC X(14) VALUE SPACES.
             88 LB-RES-PASS                  VALUE 'Pass'.
             88 LB-RES-FAIL                  VALUE 'Fail'.
             88 LB-RES-UNKNOWN               VALUE 'Screen Unknown'.
             88 LB-RES-NA                    VALUE 'Not Run'.
          05 CLSE-R-2              PIC X(01) VALUE ')'.
          05 FILLER                PIC X(01) VALUE SPACES.
          05 MSG-TEXT              PIC X(16) VALUE 'No error message'.

      * This variable holds the REQUESTNAME
      * instructing the runtime as to which Service Flow to execute
       01 SFR-REQUEST-NAME         PIC X(08) VALUE 'SFFEXAM0'.

       01 CHANNEL-NAME             PIC X(16) VALUE 'SFR-DATA-CHANNEL'.
       01 REQUEST-CONT-NAME        PIC X(16) VALUE 'DFHMAC-REQUESTV1'.
       01 REQUEST-CONT.
      * COPY DFHMAHRV.
          10 DFHMAHR-REQUESTV1.
             15  DFHMAHR-REQUESTNAME         PIC X(08) VALUE SPACES.

       01 DATA-CONT-NAME           PIC X(16) VALUE 'DFHMAC-USERDATA '.
       01 SFR-DATA-INPUT.
          05 PROGLINK              PIC X(01) VALUE 'Y'.
             88 PROGLINK-YES                 VALUE 'Y'.
             88 PROGLINK-NO                  VALUE 'N'.
          05 LINK3270              PIC X(01) VALUE 'Y'.
             88 LINK3270-YES                 VALUE 'Y'.
             88 LINK3270-NO                  VALUE 'N'.
       01 SFR-DATA-RETURN.
          05 PROGLINK-RESPONSE     PIC X(08) VALUE SPACES.
          05 LINK3270-RESPONSE     PIC X(08) VALUE SPACES.

       01 ERROR-CONT-NAME          PIC X(16) VALUE 'DFHMAC-ERROR    '.
       01 ERROR-CONT.
      * COPY DFHMAHEV.
          10  DFHMAHE-ERROR.
              15  DFHMAHE-RETURNCODE        PIC S9(9) BINARY VALUE 0.
              15  DFHMAHE-COMPCODE          PIC S9(9) BINARY VALUE 0.
              15  DFHMAHE-MODE              PIC S9(9) BINARY VALUE 0.
              15  DFHMAHE-SUSPSTATUS        PIC S9(9) BINARY VALUE 0.
              15  DFHMAHE-ABENDCODE         PIC X(4)  VALUE SPACES.
              15  DFHMAHE-MESSAGE           PIC X(12) VALUE SPACES.
              15  DFHMAHE-FAILED-PROCNAME   PIC X(36) VALUE SPACES.
              15  DFHMAHE-FAILED-PROCTYPE   PIC X(8)  VALUE SPACES.
              15  DFHMAHE-FAILED-TRANID     PIC X(4)  VALUE SPACES.
              15  DFHMAHE-FAILED-PROGRAM    PIC X(8)  VALUE SPACES.
              15  DFHMAHE-FAILED-NODE       PIC X(32) VALUE SPACES.
              15  DFHMAHE-BRIDGE-RC         PIC S9(9) BINARY VALUE 0.
              15  DFHMAHE-STATETOKEN        PIC X(16) VALUE SPACES.

       01 CICS-RESP                PIC S9(8) COMP.

       01 QUERY-INPUT              PIC X(30) VALUE SPACES.
       01 QUERY-OUTPUT             PIC X(08) VALUE SPACES.

       01 QUERY-QUESTION           PIC X(30) VALUE
                                       'WHAT IS THE MEANING OF LIFE?  '.
       01 QUERY-ANSWER             PIC X(08) VALUE 'FORTYTWO'.
       01 QUERY-BADRESPONSE        PIC X(08) VALUE 'DONTKNOW'.
       01 QUERY-REQ-CONT-NAME      PIC X(16) VALUE 'QUESTION-INPUT  '.
       01 QUERY-RESP-CONT-NAME     PIC X(16) VALUE 'QUESTION-OUTPUT '.

       LINKAGE SECTION.

      *
       PROCEDURE DIVISION.

      ******************************************************************
      *                                                                *
      * Main line code begins                                          *
      *                                                                *
      ******************************************************************

      * Test if this application has been initiated to:
      * - Execute the example Service Flow (RUN-SERVICEFLOW)
      * - Test Program Link in Service Flow execution (ACTION-REQUEST)
           IF (EIBTRNID EQUAL 'SFF1') OR (EIBTRNID EQUAL 'sff1')
              GO TO RUN-SERVICEFLOW
           ELSE
              GO TO ACTION-REQUEST
           END-IF.

       RUN-SERVICEFLOW.
      * Parse the input data into parts
           EXEC CICS RECEIVE INTO(SCREEN-INPUT-STRING)
                             NOTRUNCATE
                             RESP(CICS-RESP)
           END-EXEC.
           UNSTRING SCREEN-INPUT-STRING
                    DELIMITED BY ALL SPACE
                    INTO  TRAN-ID
                          TRAN-ARG.

      * Use screen data to set up input parameters for Service Flow
      * This input data will set flags to test:
      * Program Links and/or Link3270 Bridge Setup
           SET PROGLINK-YES TO TRUE.
           SET LINK3270-YES TO TRUE.

           IF (TRAN-ARG EQUAL 'PL') OR
              (TRAN-ARG EQUAL 'pl')
      * Only test Program Link
              SET LINK3270-NO TO TRUE
           ELSE
              IF (TRAN-ARG EQUAL 'LB') OR
                 (TRAN-ARG EQUAL 'lb')
      * Only test Link3270 Bridge
                 SET PROGLINK-NO TO TRUE
              END-IF
           END-IF.

      * Make the request to initiate the Service Flow
       CALL-SERVCICEFLOW.

      * Create the runtime Request container
      * (using the requestname for the Service Flow)
           MOVE SFR-REQUEST-NAME TO DFHMAHR-REQUESTNAME.
           EXEC CICS PUT CONTAINER(REQUEST-CONT-NAME)
                         CHANNEL(CHANNEL-NAME)
                         FROM(REQUEST-CONT)
                         FLENGTH(LENGTH OF REQUEST-CONT)
           END-EXEC.
      * Create the userdata container
           EXEC CICS PUT CONTAINER(DATA-CONT-NAME)
                         CHANNEL(CHANNEL-NAME)
                         FROM(SFR-DATA-INPUT)
                         FLENGTH(LENGTH OF SFR-DATA-INPUT)
           END-EXEC.

      * Call the Service Flow Runtime to start Service Flow
           EXEC CICS LINK PROGRAM('DFHMADPL')
                          CHANNEL(CHANNEL-NAME)
           END-EXEC.

       CHECK-SERVICEFLOW.
      * Check the response from the Service Flow execution and
      * prepare output for screen

      * Check for existance of the runtime Error container
           EXEC CICS GET CONTAINER(ERROR-CONT-NAME)
                         CHANNEL(CHANNEL-NAME)
                         INTO(ERROR-CONT)
                         RESP(CICS-RESP)
           END-EXEC.
           IF CICS-RESP EQUAL DFHRESP(NORMAL)
              MOVE DFHMAHE-MESSAGE TO MSG-TEXT
                                   OF SCREEN-OUTPUT-STRING
           END-IF.

      * Acquire data from Service Flow
           EXEC CICS GET CONTAINER(DATA-CONT-NAME)
                         CHANNEL(CHANNEL-NAME)
                         INTO(SFR-DATA-RETURN)
                         RESP(CICS-RESP)
           END-EXEC.
           IF CICS-RESP NOT EQUAL DFHRESP(NORMAL)
              SET PL-RES-FAIL TO TRUE
              SET LB-RES-FAIL TO TRUE
              GO TO REPLY-SCREEN
           END-IF.

      * Check response from Program Link test and prepare response
           IF PROGLINK-YES
              IF PROGLINK-RESPONSE = QUERY-ANSWER
                 SET PL-RES-PASS TO TRUE
              ELSE
                 SET PL-RES-FAIL TO TRUE
              END-IF
           ELSE
              SET PL-RES-NA TO TRUE
           END-IF.

      * Check response from Link3270 Bridge test and prepare response
           IF LINK3270-YES
              IF LINK3270-RESPONSE = 'DFHMA0H '
                 SET LB-RES-PASS TO TRUE
              ELSE
                 IF LINK3270-RESPONSE = 'UNKNOWN '
                    SET LB-RES-UNKNOWN TO TRUE
                 ELSE
                    SET LB-RES-FAIL TO TRUE
                 END-IF
              END-IF
           ELSE
              SET LB-RES-NA TO TRUE
           END-IF.

       REPLY-SCREEN.
      * Report results to the screen
           EXEC CICS SEND CONTROL ERASE END-EXEC.
           EXEC CICS SEND CONTROL CURSOR(00) END-EXEC.
           EXEC CICS SEND FROM(SCREEN-OUTPUT-STRING)
                          LENGTH(LENGTH OF SCREEN-OUTPUT-STRING )
           END-EXEC.

           GO TO COMMAND-RETURN.

       COMMAND-RETURN.
           EXEC CICS RETURN
           END-EXEC.


       ACTION-REQUEST.
      * Application has been called to test Program Link setup
      * It will respond (via containers) to the simple question:
      * Question: "What is the meaning of life?"
      * Answer:   "Forty two" :)

      * Get question
           EXEC CICS GET CONTAINER (QUERY-REQ-CONT-NAME)
                         INTO (QUERY-INPUT)
           END-EXEC.

           IF QUERY-INPUT EQUAL TO QUERY-QUESTION
      * Respond to question
              EXEC CICS PUT CONTAINER (QUERY-RESP-CONT-NAME)
                            FROM (QUERY-ANSWER)
                            FLENGTH (LENGTH OF QUERY-OUTPUT)
              END-EXEC
           ELSE
      * Or question was not as expected
              EXEC CICS PUT CONTAINER (QUERY-RESP-CONT-NAME)
                            FROM (QUERY-BADRESPONSE)
                            FLENGTH (LENGTH OF QUERY-OUTPUT)
              END-EXEC
           END-IF.
           GO TO COMMAND-RETURN.
